/* fio.h: File IO header file */
/* Copyright (c) 2000-2003 Fabien Tassin <fta@sofaraway.org> */

#ifndef _FIO_H_
#define _FIO_H_

typedef struct _FIO {
  int   fh;
  char *buffer;
  char *start;
  char *end;
  int   size;
  int   status;
  int   debug;
} FIO;

#define FIO_BUFFER  8192

#define FIO_OK         0
#define FIO_ERROR      1
#define FIO_TOOLONG    2

/* initialize a FIO struct given an already openned file */
FIO* fio_init(int fh);

void fio_free(FIO *fio);

/* read a line in the given filehandle */
char *fio_readline(FIO* fio);

/* write the buffer into the filehandle ('\r\n' added) */
int fio_writeline(FIO *fio, char* buf);

/* write the buffer into the filehandle (no '\r\n' added) */
int fio_write(FIO *fio, char* buf);

#define fio_error(fio)   ((fio)->status > 0)
#define fio_toolong(fio) ((fio)->status == FIO_TOOLONG)

#endif /* _FIO_H_ */
